;PCI structures include file
;written by John Baldwin for Phoenix Systems, Inc. (name?), 1997

DISPLAY "    PCI BIOS Structures and Equates"

PCI_INT1A_ADDRESS  EQU       000FFE6Eh ;physical address of default Int 1Ah handler
                                       ;for PCI functions/ only handles 16-bit code

BIOS32_PCI_ID      EQU       'ICP$'    ;BIOS32 service identifier for PCI BIOS

;Function equates for service
PCI_FUNCTION_ID    =        0B1h       ;value of AH, all rest are for AL
PCI_BIOS_PRESENT   =         01h
PCI_FIND_DEVICE    =         02h
PCI_FIND_CLASS_CODE =        03h
PCI_GENERATE_SPECIAL_CYCLE = 06h
PCI_READ_CONFIG_BYTE =       08h
PCI_READ_CONFIG_WORD =       09h
PCI_READ_CONFIG_DWORD =      0Ah
PCI_WRITE_CONFIG_BYTE =      0Bh
PCI_WRITE_CONFIG_WORD =      0Ch
PCI_WRITE_CONFIG_DWORD =     0Dh

;Return Codes - returned in AH
PCI_SUCCESSFUL          =    00h
PCI_FUNC_NOT_SUPPORTED  =    81h
PCI_BAD_VENDOR_ID       =    83h
PCI_DEVICE_NOT_FOUND    =    86h
PCI_BAD_REGISTER_NUMBER =    87h

